cherry-picked release script changes from fb1c569bc48ecf8d8adc79af59fed680aa12d3dc
[ACE_TAO.git] / ACE / bin / generate_rel_manpages
bloba8e4b2a34fb1a8ee7c6fc04b4e15429bf2650af0
1 eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
2     & eval 'exec perl -S $0 $argv:q'
3     if 0;
5 use strict;
6 require Cwd;
9 ###########
10 ###### Sanity Checks
11 ##########
13 my  $perl_path = '/usr/bin/perl';
15 my $status= 0;
17 &can_run($perl_path.' -V') ||
18   die "$0: perl path is incorrect, please fix the script\n";
20 my  $doxy_path = '/usr/local/bin';
22 $ENV{'PATH'} = $ENV{'PATH'}.':'.$doxy_path;
24 print "Starting doxygen document generation \n";
26 my $chgrp = 'chgrp';
27 my $cpio = 'cpio';
28 my $date = 'date';
29 my $egrep = 'egrep';
30 my $find = 'find';
31 my $gzip = 'gzip';
32 my $bzip = 'bzip2';
33 my $tar = 'tar';
34 my $mv = 'mv -f';
35 my $scp = 'scp ';
36 my $rm = 'rm -f';
37 my $cp = 'cp -f';
38 my $md5sum = 'md5sum';
39 my $shell_cd = 'cd';
40 my $cksum_ext = 'md5';
41 my $redirect =  '>';
42 my $checksum = '$md5sum';
44 $SIG{'HUP'} = $SIG{'INT'} = $SIG{'QUIT'} = $SIG{'TERM'} = 'cleanup';
46 my $release_filter = '\\( -name .svn -o -name build \\) -prune -o ' .
47                      '! -name \'.\#*\' ! -name \'\#*\' ! -name \'*~\' ' .
48                      '! -name \'*.MAK\' -print';
50 my $bin_files =
51     "\"\\.mak|\\.mdp|\\.ide|\\.exe\|\\.ico\|\\.gz\|\\.zip\|" .
52     "\\.gif|\\.vcp|\\.vcproj|\\.vcw|\\.sln\"";
54 ########
55 ######## Main execution thread.
56 ########
57 &ex ("bin/generate_doxygen.pl -is_release -perl_path $perl_path")
58     && die "$0: failed to generate ACE man pages\n";
60 my $build_command =
61     "$find ./html $release_filter | $cpio -o -H tar | " .
62     "$gzip -9 > ACE-html.tar.gz && ".
63     "$find ./html $release_filter | $cpio -o -H tar | " .
64     "$bzip -9 > ACE-html.tar.bz2 && ".
65     "$find ./html $release_filter | $egrep -v $bin_files | " .
66     "zip ACE-html.zip -q9@ &&" .
67     "md5sum ACE-html.tar.gz > ACE-html.tar.gz.md5 &&" .
68     "md5sum ACE-html.tar.bz2 > ACE-html.tar.bz2.md5 &&" .
69     "md5sum ACE-html.zip > ACE-html.zip.md5;";
71 &ex ($build_command)
72     && die "$0: failed to package ACE man pages\n";
74 print "Finished doxygen document generation \n";
76 exit $status;
79 ########
80 ######## Verify that a command can be executed, return 1 on sucess
81 ########
82 sub can_run {
83   my $command = shift;
85   open (RUN, "$command 2>&1 |")
86     || return 0;
87   while (<RUN>) {}
88   close(RUN)
89     || return 0;
90   return 1;
93 ########
94 ######## Execute a command, unless -n had been specified.  Return value
95 ######## of 0 indicates success.
96 ########
97 sub ex ()
99   my ($command) = @_;
101   print "Command is $command \n";
102   system ("$command");